/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.lobby.particle.elements;

import de.steamwar.lobby.particle.ParticleData;
import de.steamwar.lobby.particle.ParticleElement;
import de.steamwar.lobby.particle.ParticleTickType;

public abstract class DelegatingParticleElement implements ParticleElement {

    protected final ParticleElement particleElement;

    protected DelegatingParticleElement(ParticleElement particleElement) {
        this.particleElement = particleElement;
    }

    public abstract String attribute();

    @Override
    public void aggregateAttributes(ParticleData particleData) {
        String attribute = attribute();
        if (attribute != null) {
            particleData.add(attribute);
        }
        particleElement.aggregateAttributes(particleData);
    }

    @Override
    public ParticleTickType tickType() {
        return particleElement.tickType();
    }
}
